package net.awired.ajsl.core.lang.reflect;

import java.lang.reflect.GenericSignatureFormatError;
import java.lang.reflect.MalformedParameterizedTypeException;
import java.lang.reflect.ParameterizedType;

public final class ReflectTool {

    private ReflectTool() {
    }

    public static boolean classImplement(Class<?> clazz, Class<?> implement) {
        Class<?> current = clazz;
        while (current != null) {
            if (current.equals(implement)) {
                return true;
            }
            Class<?>[] interfaces = current.getInterfaces();
            for (Class<?> class1 : interfaces) {
                if (classImplement(class1, implement)) {
                    return true;
                }
            }
            current = current.getSuperclass();
        }
        return false;
    }

    public static Class<?> getClassDeclaredInSuperClassGeneric(Object extendedObjWithDeclaredGenerics, int genericPos)
            throws GenericSignatureFormatError, TypeNotPresentException, MalformedParameterizedTypeException,
            MalformedParameterizedTypeException {
        ParameterizedType parameterizedType = (ParameterizedType) extendedObjWithDeclaredGenerics.getClass()
                .getGenericSuperclass();
        return (Class<?>) parameterizedType.getActualTypeArguments()[genericPos];
    }
}
