package net.awired.ajsl.core.servlet;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Set;
import javax.servlet.ServletContext;
import com.google.common.io.ByteStreams;

public class ContextUtils {
    public static void servletContextResourceToFile(ServletContext context, String contextPath, String output)
            throws IOException {
        @SuppressWarnings("unchecked")
        Set<String> resources = context.getResourcePaths(contextPath);
        if (resources == null) {
            new File(output + contextPath).mkdirs();
            return;
        }
        for (String resource : resources) {
            InputStream resourceAsStream = context.getResourceAsStream(resource);
            if (resourceAsStream == null) {
                // this should be a directory
                servletContextResourceToFile(context, resource, output);
            } else {
                // this is a file
                String full = output + resource;
                new File(full.substring(0, full.lastIndexOf("/"))).mkdirs();
                FileOutputStream outFile = new FileOutputStream(full);
                ByteStreams.copy(resourceAsStream, outFile);
            }
        }
    }
}
